#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=TOOLS_light.ico
#AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_UseX64=n
#AutoIt3Wrapper_Res_Comment=Official topic : http://www.rejetto.com/forum/index.php?topic=7080.0
#AutoIt3Wrapper_Res_Description=Configuration files maker for Stunnel and HFS.
#AutoIt3Wrapper_Res_Fileversion=0.7.0.0
#AutoIt3Wrapper_AU3Check_Stop_OnWarning=y
#AutoIt3Wrapper_Tidy_Stop_OnError=n
#AutoIt3Wrapper_Run_Obfuscator=y
#Obfuscator_Parameters=/striponly
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
; AutoIt Version: 3.0
; Language:       Franglais
; Platform:       Win NT / XP
; Author:         AvvA
;
; Script Function:
;   Prepare the Wan/Stunnel/HFS link, and create the certificate & key to use SSL certificate (x509v3).
;~ ;   As selfsigned certificate, visitors will be asked to add an exception to your site certificate.
;   ! Require at least one .lng file & .ini !


#include <Constants.au3>
#include <GuiConstantsEx.au3>
#include <ButtonConstants.au3>
#include <StaticConstants.au3>


; Declare some variables
Global $code_lang = "", $lang_def = "", $lang_cur = "", $lang_cur_text = "", $inifile = "", $lang_def_ini = "", $hfsini_1stline = "", $color = "blanc"
; files
$hfsinifile = @ScriptDir & "\sHFS\hfs.ini"
$hfseventsfile = @ScriptDir & "\sHFS\hfs.events"
$stunnelconffile = @ScriptDir & "\sHFS\stunnel\hfstunel.conf"
$pemconffile = @ScriptDir & "\sHFS\stunnel\pem.conf"
$stunnelpemfile = @ScriptDir & "\sHFS\stunnel\hfstunel.pem"
$stunnelpemfilename = "hfstunel.pem"
$opensslexefile = @ScriptDir & "\sHFS\stunnel\openssl.exe"
$hfsexefile = @ScriptDir & "\sHFS\hfs.exe"

;check existence of confmakr.ini
If FileExists(@ScriptDir & "\confiles\confmakr.ini") Then
	$inifile = True
ElseIf FileExists(@ScriptDir & "\confiles\language\english.lng") Then
	MsgBox(64, "Error !", "confmakr.ini file is missing, default english language will be used...")
Else
	MsgBox(64, "Error !", "confmakr.ini & english language file's missing, you'll get variable names...")
EndIf

; try to read default language in ini file, if nothing keep english as default
If $inifile = True Then
	$lang_def_ini = IniReadSection(@ScriptDir & '\confiles\confmakr.ini', "Default")
	If IsArray($lang_def_ini) Then $lang_def = FileRead(@ScriptDir & "\confiles\language\" & $lang_def_ini[1][1] & ".lng")
Else
	$lang_def = FileRead(@ScriptDir & "\confiles\language\english.lng")
EndIf

;try to determine language to use according to Windows's language code in use
If $inifile = True Then $code_lang = IniReadSection(@ScriptDir & '\confiles\confmakr.ini', "Languages")
If IsArray($code_lang) Then
	For $x = 1 To $code_lang[0][0]
		If $code_lang[$x][0] = @OSLang Then
			$lang_cur = FileRead(@ScriptDir & "\confiles\language\" & $code_lang[$x][1] & ".lng")
			$lang_cur_text = $code_lang[$x][1]
		EndIf
	Next
EndIf


;find loopback & local network ip & all relatives things
TCPStartup()
$loopbackip = TCPNameToIP("loopback")
$winlocalip = TCPNameToIP(@ComputerName)
TCPShutdown()


Global $wingateway, $winsubnetmask
Func wmi_query()
	$objWMIService = ObjGet("winmgmts:{impersonationLevel=Impersonate}!\\.\root\cimv2")
	If Not IsObj($objWMIService) Then Return "nok"

	$colAdapters = $objWMIService.ExecQuery("SELECT * FROM Win32_NetworkAdapterConfiguration WHERE IPEnabled = True")
	For $objAdapter In $colAdapters
		If Not ($objAdapter.IPAddress) = " " Then
			For $i = 0 To UBound($objAdapter.IPAddress) - 1
				If $objAdapter.IPAddress($i) == $winlocalip Then
					$wingateway = $objAdapter.DefaultIPGateway($i)
					$winsubnetmask = $objAdapter.IPSubnet($i)
				EndIf
			Next
		EndIf
	Next
EndFunc   ;==>wmi_query
wmi_query()

If $wingateway = "" Then $wingateway = _GetText("no_gateway")

Dim $ar_broadcast_cidr[4], $ar_subnet[4] ; , $true_subnet
$ar_ip = StringSplit($winlocalip, ".", 2)
$ar_mask = StringSplit($winsubnetmask, ".", 2)

;find subnet
For $x = 0 To 3
	$ar_subnet[$x] = BitAND($ar_ip[$x], $ar_mask[$x])
	$ar_broadcast_cidr[$x] = BitOR($ar_subnet[$x], 255 - $ar_mask[$x])
	;	$str_subnet &= $ar_subnet[$x]
	;		if $x<3 then $str_subnet &= "."
Next

; create hfs subnet noban mask
$hfs_subnet_pass = ""
For $x = 0 To 3
	If $ar_mask[$x] <> 255 And $ar_subnet[$x] = 0 Then
		$hfs_subnet_pass &= "*"
		ExitLoop
	Else
		$hfs_subnet_pass &= $ar_subnet[$x]
		If $x < 3 Then $hfs_subnet_pass &= "."
	EndIf
Next


; GUI initiate
$gui = GUICreate(_GetText("gui_title"), 330, 378)

$btn_advanced = GUICtrlCreateCheckbox("+", 309, 2, 20, 18, BitOR($BS_AUTOCHECKBOX, $BS_ICON, $BS_PUSHLIKE))
GUICtrlSetResizing(-1, $GUI_DOCKMENUBAR)
GUICtrlSetTip(-1, _GetText("btn_advanced2easy"))

$tab = GUICtrlCreateTab(0, 0, 330, 345)
GUICtrlSetResizing(-1, 96) ;bottom+top

; All tabs are individually enclosed in function to be able to destroy and create the tab on the fly, in others words, for the easy/advanced switch.
; This require that all variables declared in theses tab functions are pre-declared as global, for the final loop-functions to work properly.
Global $mode, $btn_scheme, $scheme_router, $scheme_FW, $scheme_stun, $scheme_HFS, $scheme_loopback, $cert_time, $cb_key_encrypt, $key_bits, $tab_advanced
Global $progression, $btn_tuto_filezilla, $btn_hfs_beta, $btn_tuto_stunlog, $btn_tuto_principal, $btn_link_stunnel, $btn_link_openssl, $btn_link_hfs, $btn_link_sHFS, $tab_about
Global $cb_hfs_run_stunnel, $cb_hfs_exit_stunnel, $cb_hfs_del_stunlog, $cb_hfs_saveopt_onexit, $cb_hfs_browse_localhost, $cb_hfs_dont_search_betterip, $cb_hfs_dont_find_extip, $cb_hfs_dont_incl_port, $cb_hfs_https, $cb_hfs_ban_noreply, $cb_hfs_ban_all, $cb_hfs_listenon, $local_network, $cb_local, $hfs_a2n_2_name, $hfs_a2n_2_ip, $hfs_a2n_1_name, $hfs_a2n_1_ip, $cb_hfs_a2n, $local_ip, $cb_stun_local_opt, $hfs_stunlog_level, $cb_hfs_stunlog, $cb_no_stunlog, $tab_HFS
Global $stunout_port, $stunout_ip, $hfs_port, $hfs_ip, $get_ip_alt, $get_ext_ip, $ext_ip, $btn_fillurl, $cert_CN, $cert_OU, $cert_O, $cert_L, $cert_ST, $cert_C, $btn_cert_info, $tab_common
Global $tab_easy, $easy_ip, $easy_port, $easy_CN, $btn_probe_port, $local_user_ip, $port_answer, $counter
Global $btn_shortcut, $btn_quit, $btn_launchquit, $btn_makeall, $tab_files, $cb_do_only_key
Global $use_dns, $use_dyndns, $dns_icon, $dn_label
Global $all_bars, $easy_stunport, $easy_hfsport, $legend_dns, $legend_dyndns

; BUTTONS
$btn_makeall = GUICtrlCreateButton("Do it !", 100, 345, 132, 32, $BS_ICON)
GUICtrlSetImage(-1, "shell32.dll", 151)
GUICtrlSetTip(-1, _GetText("btn_makefiles_tip"))
GUICtrlSetResizing(-1, 576)
$btn_launchquit = GUICtrlCreateButton(_GetText("btn_launchquit"), 2, -1, 32, 32, $BS_ICON)
GUICtrlSetImage(-1, @ScriptDir & "\confiles\icons\shortcut.ico", -1)
GUICtrlSetTip(-1, _GetText("btn_launchquit_tip"))
GUICtrlSetResizing(-1, 576)
$btn_quit = GUICtrlCreateButton(_GetText("btn_quit"), 296, -1, 32, 32, $BS_ICON)
GUICtrlSetImage(-1, "shell32.dll", 28)
GUICtrlSetTip(-1, _GetText("btn_quit_tip"))
GUICtrlSetResizing(-1, 576)
$btn_shortcut = GUICtrlCreateButton(_GetText("btn_shortcut"), 42, -1, 32, 32, $BS_ICON)
GUICtrlSetImage(-1, "shell32.dll", 30)
GUICtrlSetTip(-1, _GetText("btn_shortcut_tip"))
GUICtrlSetResizing(-1, 576)
;~ $btn_readhfsini = GUICtrlCreateButton(_GetText("btn_readhfsini"), 90, -1, 32, 32, $BS_ICON)
;~ GUICtrlSetImage(-1, "shell32.dll", 134)
;~ GUICtrlSetTip(-1, _GetText("btn_readhfsini_tip"))

;~ ; Determine existence of hfs.ini file, if false, unactive the "read hfs.ini" button.
;~ 	If $inifile <> True Then
;~ 		ControlDisable($gui, "", $btn_readhfsini)
;~ 	EndIf




; Easy frontend
; All defaults options will be taken for the advanced options not showned in here.
Func tab_easy()
	$tab_easy = GUICtrlCreateTabItem(_GetText("tab_easy"))

	GUICtrlCreateGroup(_GetText("this_place"), 5, 30, 318, 180, $BS_RIGHT)
	GUICtrlSetFont(-1, 7, 800)

	$btn_cert_info = GUICtrlCreateButton(_GetText("cert_CN_btn"), 135, 36, 32, 32, $BS_ICON)
	GUICtrlSetImage(-1, "shell32.dll", 324)

	GUICtrlCreateGroup(_GetText("this_computer"), 15, 40, 100, 160)
	GUICtrlSetFont(-1, 7, 800)
	;hfs icon & port
	$var4tip = GUICtrlCreateIcon(@ScriptDir & "\sHFS\hfs273a_FR.exe", 0, 20, 64, 32, 32)
	If $var4tip = 0 Then $var4tip = GUICtrlCreateIcon(@ScriptDir & "\sHFS\hfs.exe", 0, 20, 64, 32, 32)

	$easy_hfsport = GUICtrlCreateLabel("44300", 45, 84)
	GUICtrlSetFont(-1, 7)
	GUICtrlSetColor(-1, 0x1987E6)
	GUICtrlSetTip($var4tip, "HTTP File Server")
	;stunnel icon & port
	GUICtrlCreateIcon(@ScriptDir & "\sHFS\stunnel\stunnel.exe", 0, 20, 110, 32, 32)
	GUICtrlSetTip(-1, "Stunnel")
	$easy_stunport = GUICtrlCreateLabel("55555", 55, 126)
	GUICtrlSetFont(-1, 7)
	GUICtrlSetColor(-1, 0x1987E6)
	;hfs http
	h_bar("_", 46, 63, 0x60A030, 0x80C060, "localhttp_1", 9, 2) ;hfs2fw
	v_bar("|", 32, 89, 0x60A030, 0x80C060, "", 2, 2)
	;stunnel
	h_bar("_", 20, 125, 0xFFFFFF, 0xFFFFFF, "", 2, 4)
	v_bar("|", 31, 130, 0xCC0000, 0xFF0000, "", 1, 3)
	h_bar("_", 33, 125, 0xCC0000, 0xFF0000, "", 11, 3)
	GUICtrlCreateLabel("|", 31, 130)
	;local ip
	GUICtrlCreateLabel(_GetText("localip_label"), 20, 165)
	$local_user_ip = GUICtrlCreateInput($winlocalip, -1, 178, 80, 18)
	GUICtrlSetLimit(-1, 15)
	GUICtrlSetTip(-1, _GetText("local_user_ip_tip"))
	;firewall icon
	GUICtrlCreateIcon(@ScriptDir & "\confiles\icons\firewall.ico", -1, 95, 64, 20, 90)
	GUICtrlSetTip(-1, _GetText("icon_firewall"))


	GUICtrlCreateGroup(_GetText("switch"), 126, 84, 47, 25)
	GUICtrlSetFont(-1, 7, 800)

	h_bar("_", 115, 85, 0x60A030, 0x80C060, "localhttp_2", 2, 2) ;fw2switch
	h_bar("_", 115, 91, 0xCC0000, 0xFF0000, "", 2, 2)

	GUICtrlCreateIcon(@ScriptDir & "\confiles\icons\socket.ico", -1, 126, 97, 16, 13)
	GUICtrlCreateIcon(@ScriptDir & "\confiles\icons\socket.ico", -1, 141, 97, 16, 13)
	GUICtrlCreateIcon(@ScriptDir & "\confiles\icons\socket.ico", -1, 157, 97, 16, 13)

	v_bar("|", 149, 108, 0xCC0000, 0xFF0000, "", 3, 2)
	h_bar("_", 173, 85, 0x60A030, 0x80C060, "localhttp_3", 2, 2) ;switch2lan
	h_bar("_", 173, 91, 0xCC0000, 0xFF0000, "", 2, 2)


	GUICtrlCreateGroup(_GetText("local_network"), 185, 50, 128, 65, $BS_RIGHT)
	GUICtrlSetFont(-1, 7, 800)

	$cb_local = GUICtrlCreateCheckbox(_GetText("cb_localhttp"), 190, 65, -1, 16)

	GUICtrlCreateIcon(@ScriptDir & "\confiles\icons\socket.ico", -1, 186, 97, 16, 13)


	GUICtrlCreateGroup(_GetText("router"), 128, 130, 185, 80, $BS_RIGHT)
	GUICtrlSetFont(-1, 7, 800)

	GUICtrlCreateIcon(@ScriptDir & "\confiles\icons\socket.ico", -1, 141, 135, 16, 13)

	$router_ip = GUICtrlCreateInput($wingateway, 160, 135, 80, 18)
	GUICtrlSetTip(-1, _GetText("router_ip"))
	GUICtrlSetState(-1, $GUI_DISABLE)

	GUICtrlCreateIcon(@ScriptDir & "\confiles\icons\router.ico", -1, 260, 155, 50, 31)

	GUICtrlCreateIcon(@ScriptDir & "\confiles\icons\socket.ico", -1, 275, 196, 16, 13)

	$get_ext_ip = GUICtrlCreateButton("IP", 145, 162, 28, 28, $BS_ICON)
	GUICtrlSetImage(-1, @ScriptDir & "\confiles\icons\loupe_ip.ico", -1, 0)
	GUICtrlSetTip(-1, _GetText("hfs_extip_get") & @CR & _GetText("hfs_extip_get_tip"))
	$get_ip_alt = GUICtrlCreateButton("Alt.", 180, 162, 28, 28, $BS_ICON)
	GUICtrlSetImage(-1, @ScriptDir & "\confiles\icons\loupe_ip2.ico", -1, 0)
	GUICtrlSetTip(-1, _GetText("hfs_extip_get_alt") & @CR & _GetText("hfs_extip_get_alt_tip"))
	$ext_ip = GUICtrlCreateInput("", 135, 192, 85, 18)
	GUICtrlSetLimit(-1, 15)
	GUICtrlSetTip(-1, _GetText("hfs_extip_tip"))

	GUICtrlCreateLabel(":", 221, 194)
	$stunout_port = GUICtrlCreateInput(_GetText("stun_listenport_input"), 224, 192, 44, 18)
	GUICtrlSetLimit(-1, 5)
	GUICtrlSetTip(-1, _GetText("stun_listenport_input_tip"))
	GUICtrlSetFont(-1, -1, 800)
	GUICtrlSetColor(-1, 0x1987E6)

	$use_dns = GUICtrlCreateCheckbox(_GetText("use_dns"), 5, 210, -1, 16)

	$dn_label = GUICtrlCreateLabel(_GetText("DN"), -1, 230, -1, 16)
	GUICtrlSetFont(-1, 8.5, 800)
	GUICtrlSetColor(-1, 0xCCA009)
	$cert_CN = GUICtrlCreateInput("", 28, 227, 140, 18)
	GUICtrlSetLimit(-1, 64)
	GUICtrlSetTip(-1, _GetText("easy_domain"))

	$dns_icon = GUICtrlCreateIcon(@ScriptDir & "\confiles\icons\dns.ico", -1, 167, 244, 41, 43, $BS_ICON)
	GUICtrlSetTip(-1, _GetText("icon_dns"))

	$use_dyndns = GUICtrlCreateCheckbox(_GetText("use_dyndns"), 5, 246, -1, 16)
	GUICtrlSetTip(-1, _GetText("easy_dyndns"))

	h_bar("_", 47, 58, 0xEED029, 0xEEEE00, "dnsfeed_1", 8, 2) ;dns feed ip hfs2firewall
	h_bar("_", 115, 79, 0xEED029, 0xEEEE00, "dnsfeed_2", 2, 2) ;firewall2switch
	v_bar("|", 143, 108, 0xEED029, 0xEEEE00, "dnsfeed_3", 3, 2) ;switch2router
	h_bar("_", 197, 250, 0xEED029, 0xEEEE00, "dnsfeed_4", 9, 2) ;www2dns
	v_bar("|", 278, 208, 0xEED029, 0xEEEE00, "dnsfeed_5", 3, 2) ;router2www
	GUICtrlCreateIcon(@ScriptDir & "\confiles\icons\socket.ico", -1, 141, 135, 16, 13)
	GUICtrlCreateIcon(@ScriptDir & "\confiles\icons\www.ico", -1, 251, 235, 60, 60, $BS_ICON);, $BS_ICON)
	GUICtrlSetTip(-1, _GetText("icon_dns"))

	v_bar("|", 284, 208, 0xCC0000, 0xFF0000, "", 12, 2) ;https connection
	h_bar("_", 197, 256, 0xFFA042, 0xFFB013, "dnsreq_1", 9, 2) ;dns request www2dns
	v_bar("|", 278, 293, 0xFFA042, 0xFFB013, "dnsreq_2", 3, 2) ;www2visitors


	GUICtrlCreateGroup(_GetText("V"), 170, 320, 153, 72);, $BS_RIGHT)
	GUICtrlSetFont(-1, 7, 800)

	GUICtrlCreateIcon(@ScriptDir & "\confiles\icons\socket.ico", -1, 275, 325, 16, 13)

	$btn_probe_port = GUICtrlCreateButton(_GetText("btn_probe_port"), 252, 373, -1, 18)
	GUICtrlSetTip(-1, _GetText("btn_probe_port_tip"))
	$port_answer = GUICtrlCreateLabel("", 172, 330, 148, 40)

	GUICtrlCreateGroup(_GetText("legend"), 10, 320, 150, 72)
	GUICtrlSetFont(-1, 7, 800)
	h_bar("_", 15, 325, 0x60A030, 0x80C060, "", 2, 2)
	h_bar("_", 80, 325, 0xCC0000, 0xFF0000, "", 2, 2)
	GUICtrlCreateLabel(_GetText("HTTP"), 30, 333, -1, 16)
	GUICtrlSetFont(-1, 7, 800)
	GUICtrlSetColor(-1, 0x60A030)
	GUICtrlCreateLabel(_GetText("HTTPS"), 95, 333, -1, 16)
	GUICtrlSetFont(-1, 7, 800)
	GUICtrlSetColor(-1, 0xCC0000)
	GUICtrlCreateIcon(@ScriptDir & "\confiles\icons\socket.ico", -1, 14, 348, 16, 13)
	GUICtrlCreateLabel(_GetText("legend_socket"), 30, 348, -1, 16)
	GUICtrlSetFont(-1, 7, 800)
	GUICtrlSetColor(-1, 0x353535)

	h_bar("_", 15, 355, 0xFFA042, 0xFFB013, "dnsreq_3", 2, 2)
	h_bar("_", -1, 370, 0xEED029, 0xEEEE00, "dnsfeed_6", 2, 2)
	$legend_dns = GUICtrlCreateLabel(_GetText("legend_dnsreq"), 30, 363, -1, 16)
	GUICtrlSetFont(-1, 7, 800)
	GUICtrlSetColor(-1, 0xFFA042)
	$legend_dyndns = GUICtrlCreateLabel(_GetText("legend_dnsfeed"), -1, 378, -1, 16)
	GUICtrlSetFont(-1, 7, 800)
	GUICtrlSetColor(-1, 0xDDC019)


	GUICtrlCreateTabItem("")
EndFunc   ;==>tab_easy




Func tab_common()
	$tab_common = GUICtrlCreateTabItem(_GetText("tab_common"))
	; certificate informations
	GUICtrlCreateGroup(_GetText("group_cert_title"), 5, 25, 318, 177)
	$btn_cert_info = GUICtrlCreateButton(_GetText("cert_CN_btn"), 310, 25, 18, 18, $BS_ICON)
	GUICtrlSetImage(-1, "shell32.dll", 324)

	GUICtrlCreateLabel(_GetText("cert_C"), 15, 47)
	GUICtrlCreateLabel(_GetText("cert_ST"), -1, 67)
	GUICtrlCreateLabel(_GetText("cert_L"), -1, 87)
	GUICtrlCreateLabel(_GetText("cert_O"), -1, 107)
	GUICtrlCreateLabel(_GetText("cert_OU"), -1, 127)
	GUICtrlCreateLabel(_GetText("cert_CN"), -1, 158)
	$cert_C = GUICtrlCreateInput("", 150, 45, 24, 18)
	GUICtrlSetLimit(-1, 2)
	$cert_ST = GUICtrlCreateInput("", -1, 65, 150, -1)
	GUICtrlSetLimit(-1, 128)
	$cert_L = GUICtrlCreateInput("", -1, 85, -1, -1)
	GUICtrlSetLimit(-1, 128)
	$cert_O = GUICtrlCreateInput("", -1, 105, -1, -1)
	GUICtrlSetLimit(-1, 64)
	$cert_OU = GUICtrlCreateInput("", -1, 125, -1, -1)
	GUICtrlSetLimit(-1, 32)
	$cert_CN = GUICtrlCreateInput("", -1, 155, -1, -1)
	GUICtrlSetLimit(-1, 64)
	$btn_fillurl = GUICtrlCreateButton(_GetText("cert_CN_btn"), 302, 156, 16, 16, $BS_ICON)
	GUICtrlSetImage(-1, "shell32.dll", 323, 0)
	GUICtrlSetTip(-1, _GetText("cert_CN_btn_tip"))
	GUICtrlCreateLabel(_GetText("cert_time_label"), 15, 180)
	$cert_time = GUICtrlCreateInput("3650", 150, 180, 34, 18)
	GUICtrlSetLimit(-1, 4)

	GUICtrlCreateGroup(_GetText("group_key_title"), 5, 207, 230, 40)
	GUICtrlCreateLabel(_GetText("key_bits_label"), 10, 225)
	$key_bits = GUICtrlCreateInput("2048", 105, 224, 34, 18)
	GUICtrlSetLimit(-1, 4)
	$cb_key_encrypt = GUICtrlCreateCheckbox(_GetText("key_encrypt"), 150, 225, -1, 18)
	GUICtrlSetState(-1, 1)

	GUICtrlCreateGroup(_GetText("group_IPs"), 5, 255, 318, 170)
	$get_ext_ip = GUICtrlCreateButton(_GetText("hfs_extip_get"), 15, 275, -1, 20)
	GUICtrlSetTip(-1, _GetText("hfs_extip_get_tip"))
	$ext_ip = GUICtrlCreateInput("", 150, 276, 90, 18)
	GUICtrlSetLimit(-1, 15)
	GUICtrlSetTip(-1, _GetText("hfs_extip_tip"))
	$get_ip_alt = GUICtrlCreateButton(_GetText("hfs_extip_get_alt"), 245, 275, -1, 20)
	GUICtrlSetTip(-1, _GetText("hfs_extip_get_alt_tip"))
	GUICtrlCreateLabel(_GetText("hfs_ip"), 15, 306)
	$hfs_ip = GUICtrlCreateInput($loopbackip, 15, 321, 100, 18)
	GUICtrlSetLimit(-1, 15)
	GUICtrlSetTip(-1, _GetText("hfs_ip_input_tip"))
	GUICtrlCreateLabel(":", 116, -1)
	$hfs_port = GUICtrlCreateInput(_GetText("hfs_port_input"), 119, -1, 60, 18)
	GUICtrlSetLimit(-1, 5)
	GUICtrlSetTip(-1, _GetText("hfs_port_input_tip"))
	GUICtrlCreateLabel(_GetText("stun_listenip"), 15, 347)
	$stunout_ip = GUICtrlCreateInput(_GetText("stun_listenip_input"), 15, 362, 100, 18)
	GUICtrlSetLimit(-1, 15)
	GUICtrlSetTip(-1, _GetText("stun_listenip_input_tip"))
	GUICtrlCreateLabel(":", 116, -1)
	$stunout_port = GUICtrlCreateInput(_GetText("stun_listenport_input"), 119, -1, 60, 18)
	GUICtrlSetLimit(-1, 5)
	GUICtrlSetTip(-1, _GetText("stun_listenport_input_tip"))

	GUICtrlCreateLabel(_GetText("localip_label"), 15, 385)
	$local_user_ip = GUICtrlCreateInput($winlocalip, 15, 400, 80, 18)
	GUICtrlSetLimit(-1, 15)
	GUICtrlSetTip(-1, _GetText("local_user_ip_tip"))
	$btn_probe_port = GUICtrlCreateButton(_GetText("btn_probe_port"), 105, -1, -1, 18)
	GUICtrlSetTip(-1, _GetText("btn_probe_port_tip"))

	$port_answer = GUICtrlCreateLabel("", 10, 430, 300, 35)

EndFunc   ;==>tab_common

Func tab_HFS()
	; options relatives  hfs
	$tab_HFS = GUICtrlCreateTabItem(_GetText("tab_hfstun"))

	GUICtrlCreateGroup(_GetText("group_hfs_log"), 5, 25, 318, 100)
	$cb_hfs_stunlog = GUICtrlCreateCheckbox(_GetText("cb_hfs_stunlog"), 25, 40, -1, 20)
	GUICtrlSetTip(-1, _GetText("cb_hfs_stunlog_tip"))
	GUICtrlSetState(-1, 1)
	$hfs_stunlog_level = GUICtrlCreateInput("6", 300, -1, 15, 18)
	GUICtrlSetTip(-1, _GetText("stunlog_level"))
	$cb_no_stunlog = GUICtrlCreateCheckbox(".", 8, 40, 0, 20)
	GUICtrlSetTip(-1, _GetText("cb_no_stunlog_tip"))

	$cb_stun_local_opt = GUICtrlCreateCheckbox(_GetText("cb_stun_local_opt"), 25, 60, -1, 20)
	GUICtrlSetTip(-1, _GetText("cb_stun_local_opt_tip"))
	$local_ip = GUICtrlCreateInput($winlocalip, 240, -1, 80, 18)

	$cb_hfs_a2n = GUICtrlCreateCheckbox(_GetText("cb_hfs_a2n"), 25, 80, -1, 20)
	GUICtrlSetTip(-1, _GetText("cb_hfs_a2n_tip"))
	$hfs_a2n_1_ip = GUICtrlCreateInput($winlocalip, 65, 82, 100, 18)
	GUICtrlSetTip(-1, _GetText("hfs_a2n_tip_ip"))
	$hfs_a2n_1_name = GUICtrlCreateInput("Stunnel", 175, -1, 100, 18)
	GUICtrlSetTip(-1, _GetText("hfs_a2n_tip_name"))
	$hfs_a2n_2_ip = GUICtrlCreateInput($loopbackip, 65, 102, 100, 18)
	GUICtrlSetTip(-1, _GetText("hfs_a2n_tip_ip"))
	$hfs_a2n_2_name = GUICtrlCreateInput("Local", 175, -1, 100, 18)
	GUICtrlSetTip(-1, _GetText("hfs_a2n_tip_name"))

	;confiance et scu
	GUICtrlCreateGroup(_GetText("group_hfs_security"), 5, 130, 318, 100)
	$cb_local = GUICtrlCreateCheckbox(_GetText("cb_local"), 25, 145, -1, 20)
	$local_network = GUICtrlCreateInput($hfs_subnet_pass, 240, -1, 80, 18)
	GUICtrlSetTip(-1, _GetText("localnet_input_tip"))
	$cb_hfs_listenon = GUICtrlCreateCheckbox(_GetText("cb_hfs_listenon"), 25, 165, -1, 20)
	GUICtrlSetTip(-1, _GetText("cb_hfs_listenon_tip"))
	GUICtrlSetState(-1, 1)
	$cb_hfs_ban_all = GUICtrlCreateCheckbox(_GetText("cb_hfs_banall"), -1, 185, -1, 20)
	GUICtrlSetTip(-1, _GetText("cb_hfs_banall_tip"))
	GUICtrlSetState(-1, 1)
	$cb_hfs_ban_noreply = GUICtrlCreateCheckbox(_GetText("cb_hfs_ban_noreply"), -1, 205, -1, -1)
	GUICtrlSetTip(-1, _GetText("cb_hfs_ban_noreply_tip"))
	GUICtrlSetState(-1, 1)

	;bon fonctionnement
	GUICtrlCreateGroup(_GetText("group_hfs_donotouch"), 5, 235, 318, 100)
	$cb_hfs_https = GUICtrlCreateCheckbox(_GetText("cb_hfs_https"), 25, 250, -1, 20)
	GUICtrlSetTip(-1, _GetText("cb_hfs_https_tip"))
	GUICtrlSetState(-1, 1)
	$cb_hfs_dont_incl_port = GUICtrlCreateCheckbox(_GetText("cb_hfs_dont_incl_port"), -1, 270, -1, 20)
	GUICtrlSetTip(-1, _GetText("cb_hfs_dont_incl_port_tip"))
	GUICtrlSetState(-1, 1)
	$cb_hfs_dont_find_extip = GUICtrlCreateCheckbox(_GetText("cb_hfs_dont_find_extip"), -1, 290, -1, 20)
	GUICtrlSetTip(-1, _GetText("cb_hfs_dont_find_extip_tip"))
	GUICtrlSetState(-1, 1)
	$cb_hfs_dont_search_betterip = GUICtrlCreateCheckbox(_GetText("cb_hfs_dont_search_betterip"), -1, 310, -1, 20)
	GUICtrlSetTip(-1, _GetText("cb_hfs_dont_search_betterip_tip"))
	GUICtrlSetState(-1, 1)

	;options de convenance
	GUICtrlCreateGroup(_GetText("group_hfs_convenience"), 5, 340, 318, 118)
	$cb_hfs_browse_localhost = GUICtrlCreateCheckbox(_GetText("cb_hfs_browse_localhost"), 25, 355, -1, 20)
	GUICtrlSetTip(-1, _GetText("cb_hfs_browse_localhost_tip"))
	$cb_hfs_saveopt_onexit = GUICtrlCreateCheckbox(_GetText("cb_hfs_saveopt_onexit"), 25, 375, -1, 20)
	GUICtrlSetTip(-1, _GetText("cb_hfs_saveopt_onexit_tip"))

	$cb_hfs_run_stunnel = GUICtrlCreateCheckbox(_GetText("cb_hfs_run_stunnel"), 25, 395, -1, 20)
	GUICtrlSetTip(-1, _GetText("cb_hfs_run_stunnel_tip"))
	GUICtrlSetState(-1, 1)
	$cb_hfs_exit_stunnel = GUICtrlCreateCheckbox(_GetText("cb_hfs_exit_stunnel"), 25, 415, -1, 20)
	GUICtrlSetTip(-1, _GetText("cb_hfs_exit_stunnel_tip"))
	GUICtrlSetState(-1, 1)
	$cb_hfs_del_stunlog = GUICtrlCreateCheckbox(_GetText("cb_hfs_del_stunlog"), 25, 435, -1, 20)
	GUICtrlSetTip(-1, _GetText("cb_hfs_del_stunlog_tip"))

	; +rgle FW windows

EndFunc   ;==>tab_HFS


Func tab_files()
	$tab_files = GUICtrlCreateTabItem(_GetText("tab_files"))
	$progression = GUICtrlCreateLabel("", 15, 35, 300, 100)
EndFunc   ;==>tab_files

Global $after_prog, $btn_read_all, $btn_read_hfsevents, $btn_read_hfsini, $btn_read_stunnelconf, $btn_read_pemconf, $btn_read_stunnelpem, $btn_erase_checked, $cb_del_GUI, $cb_del_exe, $cb_del_pemconf, $cb_del_openssl, $erased
Func check_files()
	GUISwitch($gui, $tab_files)
	$after_prog = GUICtrlCreateLabel(_GetText("after_conf_intro"), 15, 110, 300, 20)

	$btn_read_all = GUICtrlCreateButton("oO", 5, 151, 32, 32, $BS_ICON)
	GUICtrlSetImage(-1, "shell32.dll", 337)
	GUICtrlSetTip(-1, _GetText("after_conf_read_all"))
	$btn_read_hfsini = GUICtrlCreateButton("", 38, 130, 16, 16, $BS_ICON)
	GUICtrlSetImage(-1, "shell32.dll", 323, 0)
	If Not FileExists($hfsinifile) Then GUICtrlSetState(-1, $GUI_DISABLE)
	$btn_read_hfsevents = GUICtrlCreateButton("", -1, 145, 16, 16, $BS_ICON)
	GUICtrlSetImage(-1, "shell32.dll", 323, 0)
	If Not FileExists($hfseventsfile) Then GUICtrlSetState(-1, $GUI_DISABLE)
	$btn_read_stunnelconf = GUICtrlCreateButton("", -1, 160, 16, 16, $BS_ICON)
	GUICtrlSetImage(-1, "shell32.dll", 323, 0)
	If Not FileExists($stunnelconffile) Then GUICtrlSetState(-1, $GUI_DISABLE)
	$btn_read_pemconf = GUICtrlCreateButton("", -1, 175, 16, 16, $BS_ICON)
	GUICtrlSetImage(-1, "shell32.dll", 323, 0)
	If Not FileExists($pemconffile) Then GUICtrlSetState(-1, $GUI_DISABLE)
	$btn_read_stunnelpem = GUICtrlCreateButton("", -1, 190, 16, 16, $BS_ICON)
	GUICtrlSetImage(-1, "shell32.dll", 323, 0)
	If Not FileExists($stunnelpemfile) Then GUICtrlSetState(-1, $GUI_DISABLE)
	GUICtrlCreateLabel(_GetText("after_conf_read_hfsini"), 57, 131, -1, 16)
	GUICtrlCreateLabel(_GetText("after_conf_read_hfsevents"), -1, 146, -1, -1)
	GUICtrlCreateLabel(_GetText("after_conf_read_stunnelconf"), -1, 161, -1, -1)
	GUICtrlCreateLabel(_GetText("after_conf_read_pemconf"), -1, 176, -1, -1)
	GUICtrlCreateLabel(_GetText("after_conf_read_stunnelpem"), -1, 191, -1, -1)


	$btn_erase_checked = GUICtrlCreateButton("Del", 5, 231, 32, 32, $BS_ICON)
	GUICtrlSetImage(-1, "shell32.dll", 240)
	GUICtrlSetTip(-1, _GetText("after_conf_erase_checked"))
	$cb_del_GUI = GUICtrlCreateCheckbox(_GetText("del_GUI"), 40, 215, -1, 18)
	GUICtrlSetState(-1, -1)
	$cb_del_exe = GUICtrlCreateCheckbox(_GetText("after_conf_del_unused_exe"), 40, 231, -1, 18)
	GUICtrlSetState(-1, 1)
	If Not FileExists($hfsexefile) Then
		GUICtrlSetState(-1, $GUI_UNCHECKED)
		GUICtrlSetState(-1, $GUI_DISABLE)
	EndIf
	$cb_del_pemconf = GUICtrlCreateCheckbox(_GetText("after_conf_del_pemconf"), -1, 247, -1, 18)
	GUICtrlSetState(-1, 1)
	If Not FileExists($pemconffile) Then
		GUICtrlSetState(-1, $GUI_DISABLE)
		GUICtrlSetState(-1, $GUI_UNCHECKED)
	EndIf
	GUICtrlCreateIcon("shell32.dll", 161, 38, 265, 16, 16)
	GUICtrlSetTip(-1, _GetText("after_conf_del_openssl_tip"))
	$cb_del_openssl = GUICtrlCreateCheckbox(_GetText("after_conf_del_openssl"), 58, 265, -1, 18)
	If Not FileExists($opensslexefile) Then
		GUICtrlSetState(-1, $GUI_UNCHECKED)
		GUICtrlSetState(-1, $GUI_DISABLE)
	EndIf

	$erased = GUICtrlCreateLabel("", 10, 300, 300, 80)

	GUICtrlCreateTabItem("")
EndFunc   ;==>check_files


Func tab_about()
	$tab_about = GUICtrlCreateTabItem(_GetText("tab_about"))
	GUICtrlCreateLabel(_GetText("tab_about_intro"), 15, 35, 300, 40)
	$btn_link_sHFS = GUICtrlCreateButton(_GetText("btn_link_sHFS"), 110, 80, -1, -1)
	;thanks links
	GUICtrlCreateLabel(_GetText("thanks_links_label"), 15, 120, 310, 20)
	GUICtrlSetFont(-1, 7, 600)
	$btn_link_hfs = GUICtrlCreateButton(_GetText("btn_link_hfs_noimage"), 20, 135, 36, 36, $BS_ICON)
	GUICtrlSetImage(-1, @ScriptDir & "\sHFS\hfs.exe", 0)
	GUICtrlSetImage(-1, @ScriptDir & "\sHFS\hfs273a_FR.exe", 0)
	GUICtrlSetTip(-1, _GetText("btn_link_hfs_tip"))
	$btn_link_openssl = GUICtrlCreateButton(_GetText("btn_link_openssl_noimage"), 66, 135, 102, 47, $BS_ICON)
	GUICtrlSetImage(-1, @ScriptDir & "\confiles\icons\openssl.ico")
	GUICtrlSetTip(-1, _GetText("btn_link_openssl_tip"))
	$btn_link_stunnel = GUICtrlCreateButton(_GetText("btn_link_stunnel_noimage"), 178, 135, 36, 36, $BS_ICON)
	GUICtrlSetImage(-1, @ScriptDir & "\sHFS\stunnel\stunnel.exe", 0)
	GUICtrlSetTip(-1, _GetText("btn_link_stunnel_noimage_tip"))

	GUICtrlCreateLabel(_GetText("link_tuto_label"), 15, 195, 310, -1)
	GUICtrlSetFont(-1, 7, 600)
	$btn_tuto_principal = GUICtrlCreateButton(_GetText("btn_tuto_principal"), 20, 205, -1, -1)
	$btn_tuto_stunlog = GUICtrlCreateButton(_GetText("btn_tuto_stunlog"), 20, 230, -1, -1)

	GUICtrlCreateLabel(_GetText("other_links"), 15, 270, 310, -1)
	GUICtrlSetFont(-1, 7, 600)
	$btn_hfs_beta = GUICtrlCreateButton(_GetText("hfs_beta_link"), 20, 280, -1, -1)
	$btn_tuto_filezilla = GUICtrlCreateButton(_GetText("tuto_filezilla_link"), 20, 305, -1, -1)

	GUICtrlCreateTabItem("")
EndFunc   ;==>tab_about



; FUNCTIONS

Func resize_gui($y = "400")
	$size = WinGetPos(_GetText("gui_title"))
	WinMove(_GetText("gui_title"), "", $size[0], $size[1], $size[2], $y + 65)
EndFunc   ;==>resize_gui

Func easy_mode($first_launch = False, $insteasy2easy = False)
	GUICtrlSetImage($btn_advanced, @ScriptDir & "\confiles\icons\go2adv.ico", -1, 0)
	$adv2easy_prog = ""
	If $first_launch = False Then
		If $insteasy2easy = False Then
			$answer = MsgBox(305, "O", _GetText("switch_mode_warn"))
			If $answer = 2 Then ;Cancel
				GUICtrlSetState($btn_advanced, $GUI_CHECKED)
				Return
			EndIf
		EndIf
		$easy_port_int = GUICtrlRead($hfs_port)
		$easy_user_ip = GUICtrlRead($local_user_ip)
		$easy_ip = GUICtrlRead($ext_ip)
		$easy_port = GUICtrlRead($stunout_port)
		$easy_CN = GUICtrlRead($cert_CN)
		If GUICtrlRead($cb_local) = 1 Then
			$easy_localhttp = $GUI_CHECKED
		Else
			$easy_localhttp = $GUI_UNCHECKED
		EndIf
		GUICtrlDelete($tab_common)
		GUICtrlDelete($tab_HFS)
		$adv2easy_prog = GUICtrlRead($progression)
		GUICtrlDelete($tab_files)
		GUICtrlDelete($tab_about)
	EndIf

	resize_gui()
	tab_easy()
	tab_files()
	tab_about()

	$mode = "easy"
	GUICtrlSetTip($btn_advanced, _GetText("btn_easy2advanced"))
	If $first_launch = False Then
		GUICtrlSetData($easy_hfsport, $easy_port_int)
		GUICtrlSetData($ext_ip, $easy_ip)
		GUICtrlSetData($stunout_port, $easy_port)
		GUICtrlSetData($cert_CN, $easy_CN)
		If GUICtrlRead($cert_CN) <> "" Then GUICtrlSetState($use_dns, $GUI_CHECKED)
		GUICtrlSetData($local_user_ip, $easy_user_ip)
		GUICtrlSetState($cb_local, $easy_localhttp)
	EndIf
	If $insteasy2easy = False Then GUICtrlSetState($tab_easy, $GUI_SHOW)
	If $adv2easy_prog <> "" Then
		check_files()
		GUICtrlSetData($progression, $adv2easy_prog)
		;GUICtrlSetState($tab_files, $GUI_SHOW)

	Else
		check_files()
		GUICtrlSetState($tab_easy, $GUI_SHOW)
	EndIf
	$color = "blanc"
	$change_mode = True


EndFunc   ;==>easy_mode
easy_mode(True)

Func advanced_mode()
	GUICtrlSetImage($btn_advanced, @ScriptDir & "\confiles\icons\go2easy.ico", -1, 0)
	resize_gui("465")
	$hfsport_int = GUICtrlRead($easy_hfsport)
	$easy2adv_prog = GUICtrlRead($progression)
	$easy_ip = GUICtrlRead($ext_ip)
	$easy_port = GUICtrlRead($stunout_port)
	$easy_CN = GUICtrlRead($cert_CN)
	$easy_user_ip = GUICtrlRead($local_user_ip)
	If GUICtrlRead($cb_local) = 1 Then
		$easy_localhttp = $GUI_CHECKED
	Else
		$easy_localhttp = $GUI_UNCHECKED
	EndIf
	GUICtrlDelete($tab_about)
	GUICtrlDelete($tab_files)
	GUICtrlDelete($tab_easy)
	tab_common()
	tab_HFS()
	tab_files()
	tab_about()


	;GUICtrlCreateTabItem("")
	$mode = "advanced"
	GUICtrlSetTip($btn_advanced, _GetText("btn_advanced2easy"))
	GUICtrlSetData($hfs_port, $hfsport_int)
	GUICtrlSetData($local_user_ip, $easy_user_ip)
	GUICtrlSetData($ext_ip, $easy_ip)
	GUICtrlSetData($stunout_port, $easy_port)
	GUICtrlSetData($cert_CN, $easy_CN)
	GUICtrlSetState($cb_local, $easy_localhttp)
	If $easy2adv_prog <> "" Then
		check_files()
		;GUICtrlSetState($tab_files, $GUI_SHOW)
		GUICtrlSetData($progression, $easy2adv_prog)

	Else
		check_files()
		GUICtrlSetState($tab_common, $GUI_SHOW)
	EndIf
	$color = "blanc"
	$change_mode = True
	;check_files()
EndFunc   ;==>advanced_mode

$objErr = ObjEvent("AutoIt.Error", "MyErrFunc")
Func MyErrFunc()
	$hexnum = Hex($objErr.number, 8)
	If $hexnum = "80020009" Then
		GUICtrlSetData($port_answer, _GetText("PHPserver_offline"))
		Return
	EndIf
	MsgBox(0, "", "We intercepted a COM Error!!" & @CRLF & @CRLF & _
			"err.description is: " & $objErr.description & @CRLF & _
			"err.windescription is: " & $objErr.windescription & @CRLF & _
			"err.lastdllerror is: " & $objErr.lastdllerror & @CRLF & _
			"err.scriptline is: " & $objErr.scriptline & @CRLF & _
			"err.number is: " & $hexnum & @CRLF & _
			"err.source is: " & $objErr.source & @CRLF & _
			"err.helpfile is: " & $objErr.helpfile & @CRLF & _
			"err.helpcontext is: " & $objErr.helpcontext _
			)
EndFunc   ;==>MyErrFunc

Func test_port()
	GUICtrlSetData($port_answer, "")
	$port = Int(GUICtrlRead($stunout_port))
	$ip = GUICtrlRead($local_user_ip)
	If IsNumber($port) And $port <> 0 Then
		If ($port > 65535 Or $port < 1) Then
			GUICtrlSetData($port_answer, _GetText("fantasy_port1"))
			Return
		EndIf
	Else
		GUICtrlSetData($port_answer, _GetText("fantasy_port2"))
		Return
	EndIf

	TCPStartup()
	$listen = TCPListen($ip, $port, 5) ; on coute sur le port choisi
	If $listen = -1 Then
		If @error = 1 Then
			GUICtrlSetData($port_answer, _GetText("port_test_listen_failed_ip") & " " & $ip)
		ElseIf @error = 2 Then
			GUICtrlSetData($port_answer, _GetText("port_test_listen_failed_port_a") & $port & _GetText("port_test_listen_failed_port_b"))
		ElseIf @error = 10048 Then
			GUICtrlSetData($port_answer, _GetText("port_test_listen_failed_inuse_a") & $port & _GetText("port_test_listen_failed_inuse_b"))
		Else
			GUICtrlSetData($port_answer, _GetText("port_test_winapi_error") & " (" & @error & ") " & @CR & "http://msdn.microsoft.com/en-us/library/ms740668%28VS.85%29.aspx")
		EndIf
		Return
	Else
		GUICtrlSetData($port_answer, _GetText("port_test_ok_a") & $port & _GetText("port_test_ok_b"))
	EndIf

	$oHTTP = ObjCreate("winhttp.winhttprequest.5.1")
	$oHTTP.Open("GET", "http://greengiant.fr.nf/sHFS/isthisportopen.php?port=" & $port, True)
	GUICtrlSetData($port_answer, GUICtrlRead($port_answer) & @CR & _GetText("request_send_a") & "greengiant.fr.nf, " & _GetText("request_send_b"))
	$oHTTP.Send()
	ConsoleWrite(@error & "    " & $oHTTP)
	;	If

	;	Else
	GUICtrlSetData($port_answer, $oHTTP.ResponseText)
	;	EndIf

	$oHTTP = 0
	TCPCloseSocket($listen)
	TCPShutdown()
EndFunc   ;==>test_port


;Find text in choosen language file, if not found take it in default language file (define in confmakr.ini, default is english)
; if no language file, shows the text code.
Func _GetText($str)
	$_SRE = StringRegExp($lang_cur, $str & '\s?=(.*)', 1)
	If @error = 1 Or @error = 2 Then $_SRE = StringRegExp($lang_def, $str & '\s?=(.*)', 1)
	If @error = 1 Or @error = 2 Then Return $str
	If StringRight(StringToBinary($_SRE[0]), 2) = "0D" Then
		Return Execute(StringTrimRight($_SRE[0], 1))
	Else
		Return Execute($_SRE[0])
	EndIf
EndFunc   ;==>_GetText

; Create the key and certificate with OpenSSL, using the external IP and listening port of Stunnel if the site address isn't filled.
Func conf_key()
	$certC = GUICtrlRead($cert_C)
	$certST = GUICtrlRead($cert_ST)
	$certL = GUICtrlRead($cert_L)
	$certO = GUICtrlRead($cert_O)
	$certOU = GUICtrlRead($cert_OU)
	$certCN = GUICtrlRead($cert_CN)

	If $certCN = "" Then
		$extip = GUICtrlRead($ext_ip)
		$extport = GUICtrlRead($stunout_port)
		$certCN = $extip & ":" & $extport
	EndIf

	If GUICtrlRead($cert_time) <> "" Then
		$certime = GUICtrlRead($cert_time)
	Else
		$certime = "3650"
	EndIf
	If GUICtrlRead($key_bits) <> "" Then
		$keybits = GUICtrlRead($key_bits)
	Else
		$keybits = "2048"
	EndIf
	If GUICtrlRead($cb_key_encrypt) = 1 Then
		$keyencrypt = "yes"
	Else
		$keyencrypt = "no"
	EndIf

	$filecheck = FileExists($pemconffile)
	If $filecheck = 1 Then
		$ask_wtd = MsgBox(4, _GetText("warning"), _GetText("file_exist_pemconf") & @CR & _GetText("file_overwrite"))
		If $ask_wtd = 7 Then Return "nopemconf"
	EndIf
	$file = FileOpen($pemconffile, 2)
	If $file = -1 Then
		MsgBox(0, _GetText("error"), _GetText("file_creation_error"))
		Return "filerror"
	EndIf

	$prepare = "RANDFILE = ../random.rnd" & @CRLF & @CRLF & "[ req ]" & @CRLF & "default_bits = " & $keybits & @CRLF & "encrypt_key = " & $keyencrypt & @CRLF & "distinguished_name = req_distinguished_name" & @CRLF & "x509_extensions = cert_type" & @CRLF & "prompt = no" & @CRLF & @CRLF & "[ req_distinguished_name ]" & @CRLF

	FileWrite($file, $prepare)
	If $certC <> "" Then FileWriteLine($file, "C = " & $certC)
	If $certST <> "" Then FileWriteLine($file, "ST = " & $certST)
	If $certL <> "" Then FileWriteLine($file, "L = " & $certL)
	If $certO <> "" Then FileWriteLine($file, "O = " & $certO)
	If $certOU <> "" Then FileWriteLine($file, "OU = " & $certOU)
	If $certCN <> "" Then FileWriteLine($file, "CN = " & $certCN)
	FileWriteLine($file, @CRLF & "[ cert_type ]" & @CRLF & "nsCertType = server")
	FileClose($file)

	ShellExecuteWait(@ScriptDir & "\sHFS\stunnel\openssl.exe", "req -new -x509 -days " & $certime & " -nodes -config pem.conf -out " & $stunnelpemfilename & " -keyout " & $stunnelpemfilename, @ScriptDir & "\sHFS\stunnel", "open", @SW_HIDE)

	$filecheck = FileExists($stunnelpemfile)
	If $filecheck = 1 Then
		$key_file = FileRead($stunnelpemfile)
		$key_file = StringReplace($key_file, "-----END PRIVATE KEY-----", "-----END PRIVATE KEY-----" & @LF & @LF & @LF, 1)
		$extended = @extended
		If $extended = 1 Then
			$file_certkey = FileOpen($stunnelpemfile, 2)
			FileWrite($file_certkey, $key_file)
			FileClose($file_certkey)
			Return "ok_blank"
		Else
			Return "ok_noblank"
		EndIf
	Else
		Return "stunnelpemfilerror"
	EndIf

EndFunc   ;==>conf_key

; Create the stunnel.conf file
Func conf_stunnel()
	$hfsport = GUICtrlRead($hfs_port)
	$hfsip = GUICtrlRead($hfs_ip)
	$stunoutport = GUICtrlRead($stunout_port)
	$stunoutip = GUICtrlRead($stunout_ip)
	$state_cb_stun_local_opt = GUICtrlRead($cb_stun_local_opt)
	$localip = GUICtrlRead($local_ip)
	$loglvl = GUICtrlRead($hfs_stunlog_level)
	$no_stunlog = GUICtrlRead($cb_no_stunlog)

	$filecheck = FileExists($stunnelconffile)
	If $filecheck = 1 Then
		$ask_wtd = MsgBox(4, _GetText("warning"), _GetText("file_exist_stunnelconf") & @CR & _GetText("file_overwrite"))
		If $ask_wtd = 7 Then Return "nostunnelconf"
	EndIf

	$stunfile = FileOpen($stunnelconffile, 2)
	If $stunfile = -1 Then
		MsgBox(0, _GetText("error"), _GetText("file_creation_error"))
		Return "filerror"
	EndIf

	$prepare = "; Lines preceded with a ; are comments" & @CRLF & "; Empty lines are ignored" & @CRLF & "; For more options and details: see the manual (stunnel.html)" & @CRLF & @CRLF & "; Path to file with random seed data" & @CRLF & "RNDfile = ..\random.rnd" & @CRLF & @CRLF & "; The SSL library will use data from this file first to seed the random number generator." & @CRLF & "RNDoverwrite = yes" & @CRLF & @CRLF & "; File with certificate and private key" & @CRLF & "cert = " & $stunnelpemfilename & @CRLF & "key = " & $stunnelpemfilename & @CRLF & @CRLF & "; Log (1= minimal, 5=recommended, 7=all) and log file)" & @CRLF & "; Preceed with a ; to disable logging" & @CRLF
	If $no_stunlog = 1 Then $prepare &= ";"
	$prepare &= "debug = " & $loglvl & @CRLF
	If $no_stunlog = 1 Then $prepare &= ";"
	$prepare &= "output = ..\stunnel.log" & @CRLF & @CRLF & "; Some performance tuning" & @CRLF & "socket = l:TCP_NODELAY=1" & @CRLF & "socket = r:TCP_NODELAY=1" & @CRLF & @CRLF & "; Data compression algorithm: zlib or rle" & @CRLF & "compression = zlib" & @CRLF & @CRLF & "; SSL bug options / NO SSL:v2 (SSLv3 and TLSv1 is enabled)" & @CRLF & "options = ALL" & @CRLF & "options = NO_SSLv2" & @CRLF & @CRLF & "; Service-level configuration" & @CRLF & "; Stunnel listens to port " & $stunoutport & " (HTTPS) to IP " & $stunoutip & @CRLF & "; and connects to port " & $hfsport & " (HFS) on " & $hfsip & @CRLF & "[https]" & @CRLF

	FileWrite($stunfile, $prepare)
	FileWriteLine($stunfile, "accept = " & $stunoutip & ":" & $stunoutport)
	FileWriteLine($stunfile, "connect = " & $hfsip & ":" & $hfsport)
	If $state_cb_stun_local_opt = 1 Then FileWriteLine($stunfile, "local = " & $localip)
	FileWriteLine($stunfile, "TIMEOUTclose = 0")
	FileClose($stunfile)

	Return "ok"
EndFunc   ;==>conf_stunnel

; create or modify the hfs.events file.
Func conf_HFS_events()
	If GUICtrlRead($cb_hfs_run_stunnel) = 1 Or GUICtrlRead($cb_hfs_exit_stunnel) = 1 Or GUICtrlRead($cb_hfs_stunlog) = 1 Or GUICtrlRead($cb_hfs_del_stunlog) = 1 Then

		$prepare = ""
		If GUICtrlRead($cb_hfs_stunlog) = 1 Then $prepare = @CRLF & "{.set|#log|{.load|stunnel.log|from={.^#stunnel.last.}.}{.set|#stunnel.last|{.filesize|stunnel.log.}.}.}" & @CRLF & "{.if|{.^#log.}|{:" & @CRLF & "{.add to log|." & @CRLF & "Stunnel log :" & @CRLF & "{.^#log.}|Clblue.}" & @CRLF & ":}.}" & @CRLF & @CRLF & "[+start]" & @CRLF & "{.set|#stunnel.last|{.filesize|stunnel.log.}.}"
		If GUICtrlRead($cb_hfs_run_stunnel) = 1 And GUICtrlRead($cb_hfs_stunlog) = 1 Then $prepare &= @CRLF & "{.exec|stunnel\stunnel.exe " & $stunnelconffile & ".}"
		If GUICtrlRead($cb_hfs_run_stunnel) = 1 And GUICtrlRead($cb_hfs_stunlog) <> 1 Then $prepare &= @CRLF & "[+start]" & @CRLF & "{.exec|stunnel\stunnel.exe " & $stunnelconffile & ".}"
		If GUICtrlRead($cb_hfs_exit_stunnel) = 1 Then $prepare &= @CRLF & "[+quit]" & @CRLF & "{.exec|tskill stunnel.}" & @CRLF & "{.exec|taskkill /F /FI ""IMAGENAME eq stunnel*"".}"
		If GUICtrlRead($cb_hfs_del_stunlog) = 1 And GUICtrlRead($cb_hfs_exit_stunnel) = 1 Then $prepare &= @CRLF & "{.time|1|{.delete|stunnel.log.}.}"
		If GUICtrlRead($cb_hfs_del_stunlog) = 1 And GUICtrlRead($cb_hfs_exit_stunnel) <> 1 Then $prepare &= @CRLF & "[+quit]" & @CRLF & "{.time|1|{.delete|stunnel.log.}.}"

		$filecheck = FileExists($hfseventsfile)
		If $filecheck = 1 Then
			$ask_wtd = MsgBox(3, _GetText("warning"), _GetText("file_exist_hfsevents") & @CR & _GetText("file_choice"))
			If $ask_wtd = 2 Then ;cancel : keep current
				Return "nohfsevents"
			ElseIf $ask_wtd = 7 Then ;no : mod current
				$filelog = FileOpen($hfseventsfile, 1)
				If $filelog = -1 Then
					MsgBox(0, _GetText("error"), _GetText("file_modif_error"))
					Return "hfseventsmoderror"
				Else
					If GUICtrlRead($cb_hfs_stunlog) = 1 Then $prepare = @CRLF & "[+connected]" & $prepare
					FileWrite($filelog, $prepare)
					FileClose($filelog)
					Return "hfseventsmod"
				EndIf
			EndIf
		EndIf
		$filelog = FileOpen($hfseventsfile, 2)
		If $filelog = -1 Then
			MsgBox(0, _GetText("error"), _GetText("file_creation_error"))
			Return "hfseventscreaterror"
		Else
			If GUICtrlRead($cb_hfs_stunlog) = 1 Then $prepare = "[connected]" & $prepare
			FileWrite($filelog, $prepare)
			FileClose($filelog)
			Return "ok"
		EndIf

	EndIf
EndFunc   ;==>conf_HFS_events

; create or modify the hfs.ini
Func conf_HFS()

	$hfsport = GUICtrlRead($hfs_port)
	$hfsip = GUICtrlRead($hfs_ip)
	$certCN = GUICtrlRead($cert_CN)
	$localnet = GUICtrlRead($local_network)
	$hfsa2n_1ip = GUICtrlRead($hfs_a2n_1_ip)
	$hfsa2n_1name = GUICtrlRead($hfs_a2n_1_name)
	$hfsa2n_2ip = GUICtrlRead($hfs_a2n_2_ip)
	$hfsa2n_2name = GUICtrlRead($hfs_a2n_2_name)
	$extip = GUICtrlRead($ext_ip)
	$extport = ":" & GUICtrlRead($stunout_port)
	If GUICtrlRead($cb_hfs_https) = 1 And $extport = ":443" Then $extport = ""
	If $certCN = "" Then
		$certCN = $extip & $extport
	Else
		If $extip & $extport <> $certCN And StringInStr($certCN, $extport) = 0 And $extport <> "" Then
			$cert_CN_without_port = MsgBox(65, _GetText("warning"), _GetText("cert_CN_without_port"))
			If $cert_CN_without_port = 1 Then $certCN &= $extport ;ok
		EndIf
	EndIf

	; check if hfs.ini exist, if not, create it and add a first line, for the next to work...
	$filecheck = FileExists($hfsinifile)
	If $filecheck = 1 Then
		$ask_wtd = MsgBox(4, _GetText("warning"), _GetText("file_exist_hfsini") & @CR & _GetText("file_modif"))
		If $ask_wtd = 7 Then Return "nohfsini"
	Else
		$file = FileOpen($hfsinifile, 2)
		If $file = -1 Then
			MsgBox(0, _GetText("error"), _GetText("file_creation_error"))
			Return "filerror"
		EndIf
	;	FileWriteLine($file, "HFS 2.3")
		FileClose($file)
	EndIf

	make_hfsini_section()

	; process of choosen options
	IniWrite($hfsinifile, "rhoOo", "active", "yes")
	IniWrite($hfsinifile, "rhoOo", "ip", $certCN)
	IniWrite($hfsinifile, "rhoOo", "custom-ip", $certCN)
	If GUICtrlRead($cb_hfs_saveopt_onexit) = 1 Then IniWrite($hfsinifile, "rhoOo", "save-options-on-exit", "yes")
	If GUICtrlRead($cb_hfs_dont_incl_port) = 1 Then IniWrite($hfsinifile, "rhoOo", "dont-include-port-in-url", "yes")
	IniWrite($hfsinifile, "rhoOo", "port", $hfsport)
	If GUICtrlRead($cb_hfs_ban_noreply) = 1 Then IniWrite($hfsinifile, "rhoOo", "no-reply-ban", "yes")
	If GUICtrlRead($cb_hfs_https) = 1 Then IniWrite($hfsinifile, "rhoOo", "https-url", "yes")
	If GUICtrlRead($cb_hfs_dont_find_extip) = 1 Then IniWrite($hfsinifile, "rhoOo", "find-external-on-startup", "no")
	If GUICtrlRead($cb_hfs_dont_search_betterip) = 1 Then IniWrite($hfsinifile, "rhoOo", "search-better-ip", "no")
	If GUICtrlRead($cb_hfs_browse_localhost) = 1 Then IniWrite($hfsinifile, "rhoOo", "browse-localhost", "no")
	$state_cb_local = GUICtrlRead($cb_local)
	$state_hfs_listenon = GUICtrlRead($cb_hfs_listenon)
	$state_hfs_ban_all = GUICtrlRead($cb_hfs_ban_all)
	If $state_cb_local <> 1 And $state_hfs_ban_all = 1 Then
		IniWrite($hfsinifile, "rhoOo", "ban-list", "\" & $hfsip & "#|")
		If $state_hfs_listenon = 1 And $state_cb_local <> 1 Then IniWrite($hfsinifile, "rhoOo", "listen-on", $hfsip)
	ElseIf $state_cb_local = 1 And $state_hfs_ban_all = 1 Then
		IniWrite($hfsinifile, "rhoOo", "ban-list", "\" & $hfsip & ";" & $localnet & "#|")
		IniWrite($hfsinifile, "rhoOo", "listen-on", "")
	EndIf
	If GUICtrlRead($cb_hfs_a2n) = 1 Then
		If $hfsa2n_1ip <> "" And $hfsa2n_1name <> "" Then
			$a2n_1 = $hfsa2n_1name & "|" & $hfsa2n_1ip
		Else
			$a2n_1 = ""
		EndIf
		If $hfsa2n_2ip <> "" And $hfsa2n_2name <> "" Then
			$a2n_2 = $hfsa2n_2name & "|" & $hfsa2n_2ip
		Else
			$a2n_2 = ""
		EndIf
		If $a2n_1 <> "" Then $a2n_final = $a2n_1
		If $a2n_2 <> "" And $a2n_1 <> "" Then $a2n_final &= "|" & $a2n_2
		If $a2n_2 <> "" And $a2n_1 = "" Then $a2n_final = $a2n_2
		IniWrite($hfsinifile, "rhoOo", "address2name", $a2n_final)
	EndIf

	remove_hfsini_section()

	Return "ok"
EndFunc   ;==>conf_HFS


Func make_hfsini_section()
	; Search and keep the first line (usually HFS version), and also the entire file
	$file = FileOpen($hfsinifile, 0)
	$hfsini_cur = FileRead($file)
	$hfsini_1stline = FileReadLine($file, 1)
	FileClose($file)
	; replace HFS version with a ini section [temp], necessary for iniwrite to run right
	$hfsini_cur = StringReplace($hfsini_cur, $hfsini_1stline, "[rhoOo]", 1)
	; rewrite the whole content, beginning with a [temp] section, this way ini keys already existing will be replaced
	$file = FileOpen($hfsinifile, 2)
	FileWrite($file, $hfsini_cur)
	FileClose($file)
EndFunc   ;==>make_hfsini_section

Func remove_hfsini_section()
	; put back the original first line, as HFS do not use ini section
	$file = FileOpen($hfsinifile, 0)
	$hfsini_final = FileRead($file)
	$hfsini_final = StringReplace($hfsini_final, "[rhoOo]", $hfsini_1stline, 1)
	FileClose($file)
	$file = FileOpen($hfsinifile, 2)
	FileWrite($file, $hfsini_final)
	FileClose($file)
EndFunc   ;==>remove_hfsini_section


; Rename the HFS.exe file according to default language or existing language (XX) hfs[version][language].exe file. Set in confmakr.ini file.
$hfs_renamed = False
Func hfsexe_renamer()
	If $inifile = True Then
		$hfs_locale_exe = IniReadSection(@ScriptDir & '\confiles\confmakr.ini', "HFS")
		If IsArray($hfs_locale_exe) Then
			For $x = 1 To $hfs_locale_exe[0][0]
				If $hfs_locale_exe[$x][0] = $lang_cur_text Then
					FileCopy(@ScriptDir & "\sHFS\" & $hfs_locale_exe[$x][1], @ScriptDir & "\sHFS\hfs.exe", 1)
					$hfs_renamed = True
					ExitLoop
				ElseIf $x = $hfs_locale_exe[0][0] And $hfs_renamed <> True Then
					FileCopy(@ScriptDir & "\sHFS\" & $hfs_locale_exe[1][1], @ScriptDir & "\sHFS\hfs.exe", 1)
				EndIf
			Next
		EndIf
	Else
		FileCopy(@ScriptDir & "\sHFS\hfs*.exe", @ScriptDir & "\sHFS\hfs.exe", 1)
	EndIf
EndFunc   ;==>hfsexe_renamer



Func erase_files()
	$erased = ""
	If GUICtrlRead($cb_del_GUI) = 1 Then
		If DirRemove(@ScriptDir & "\confiles", 1) = 1 Then
			$erased &= _GetText("del_confiles_ok")
		Else
			$erased &= _GetText("del_confiles_nok")
		EndIf
		If FileDelete(@ScriptDir & "\confmakr.exe") = 1 Then
			$erased &= _GetText("del_confmakr_ok")
		Else
			$erased &= _GetText("del_confmakr_nok")
		EndIf
	EndIf

	If GUICtrlRead($cb_del_exe) = 1 Then
		FileMove(@ScriptDir & "\sHFS\hfs.exe", @ScriptDir & "\sHFS\savetemp.exe")
		If FileDelete(@ScriptDir & "\sHFS\hfs*.exe") = 1 Then
			$erased &= _GetText("del_exe_ok")
		Else
			$erased &= _GetText("del_exe_nok")
		EndIf
		FileMove(@ScriptDir & "\sHFS\savetemp.exe", @ScriptDir & "\sHFS\hfs.exe")
	EndIf

	If GUICtrlRead($cb_del_openssl) = 1 Then
		If FileDelete(@ScriptDir & "\sHFS\stunnel\openssl.exe") = 1 Then
			$erased &= _GetText("del_openssl_ok")
		Else
			$erased &= _GetText("del_openssl_nok")
		EndIf
	Else
		If GUICtrlRead($cb_del_pemconf) = 1 Then
			If FileDelete($pemconffile) = 1 Then
				$erased &= _GetText("del_pemconf_ok")
			Else
				$erased &= _GetText("del_pemconf_nok")
			EndIf
			If FileDelete(@ScriptDir & "\sHFS\random.rnd") = 1 Then
				$erased &= _GetText("del_rnd_ok")
			Else
				$erased &= _GetText("del_rnd_nok")
			EndIf
		EndIf
	EndIf
	Return $erased
EndFunc   ;==>erase_files


Func open_txt($file)
	If FileExists($file) Then ShellExecute("notepad", $file)
EndFunc   ;==>open_txt


Func open_pem($file)
	If Not FileExists($opensslexefile) Then
		open_txt($file)
		Return "file_no_opensslexe"
	Else
		If FileExists($file) Then
			$certinf = Run($opensslexefile & " x509 -text -in " & '"' & $file & '"', @ScriptDir & "\sHFS\stunnel", @SW_HIDE, $STDOUT_CHILD)
			$temp = ""
			While 1
				$temp &= StdoutRead($certinf)
				If @error Then ExitLoop
			WEnd
			GUICreate("OpenSSL", 425, 400, 150, -1, @SW_DISABLE, -1, $gui)
			GUISetState(@SW_SHOW)
			$tempo = StringAddCR($temp)
			GUICtrlCreateEdit($tempo, 0, 0, 419, 390)
			GUICtrlSetFont(-1, 8, 2, -1, "Lucida Console")
		EndIf
	EndIf
EndFunc   ;==>open_pem


;~ Func read_hfsini($key, $control, $checker_validator = "yes")
;~ 	If $checker_validator = "field" Then
;--------------------------;faire un switch sur le nom de la clef, pour appliquer le bon stringsplit si ncessaire
;~ 		GUICtrlSetData($control, IniRead($hfsinifile, "rhoOo", $key, ""))
;~ 	Else
;~ 		If IniRead($hfsinifile, "rhoOo", $key, "notfound") = $checker_validator then
;~ 			GUICtrlSetState($control, $GUI_CHECKED)
;~ 		Else
;~ 			GUICtrlSetState($control, $GUI_UNCHECKED)
;~ 		EndIf
;~ 	Endif
;~ EndFunc

; links related functions
Func h_bar($sign, $x, $y, $color1, $color2, $varname, $long = 1, $large = 1)
	$ptrn = ""
	For $longtemp = 1 To $long
		$ptrn &= $sign
	Next
	$keep = $varname
	If $keep = "" Then
		GUICtrlCreateLabel($ptrn, $x, $y)
	Else
		Assign($keep & "up", GUICtrlCreateLabel($ptrn, $x, $y), 2)
		Assign($varname, Eval($varname) & $keep & "up" & "|", 2)
	EndIf
	GUICtrlSetColor(-1, $color1)

	$y += 1
	For $loop = 1 To $large
		If $keep = "" Then
			GUICtrlCreateLabel($ptrn, $x, $y)
		Else
			Assign($keep & "middle" & $loop, GUICtrlCreateLabel($ptrn, $x, $y), 2)
			Assign($varname, Eval($varname) & $keep & "middle" & $loop & "|", 2)
		EndIf
		GUICtrlSetColor(-1, $color2)
		$y += 1
	Next
	; down
	If $keep = "" Then
		GUICtrlCreateLabel($ptrn, $x, $y)
	Else
		Assign($keep & "down", GUICtrlCreateLabel($ptrn, $x, $y), 2)
		Assign($varname, Eval($varname) & $keep & "down" & "|", 2)
	EndIf
	GUICtrlSetColor(-1, $color1)

	If $keep <> "" Then $all_bars &= "|" & $keep
EndFunc   ;==>h_bar

Func v_bar($sign, $x, $y, $color1, $color2, $varname, $long = 1, $large = 1, $jumps = 10)
	$keep = $varname
	For $loop = 1 To $long
		; left side
		If $keep = "" Then
			GUICtrlCreateLabel($sign, $x, $y)
		Else
			Assign($keep & "left" & $loop, GUICtrlCreateLabel($sign, $x, $y), 2)
			Assign($varname, Eval($varname) & $keep & "left" & $loop & "|", 2)
		EndIf
		GUICtrlSetColor(-1, $color1)
		; middle
		$x_temp = $x + 1
		For $loop2 = 1 To $large
			If $keep = "" Then
				GUICtrlCreateLabel($sign, $x_temp, $y)
			Else
				Assign($keep & "center" & $loop & "_" & $loop2, GUICtrlCreateLabel($sign, $x_temp, $y), 2)
				Assign($varname, Eval($keep) & $keep & "center" & $loop & "_" & $loop2 & "|", 2)
			EndIf
			GUICtrlSetColor(-1, $color2)
			$x_temp += 1
		Next
		; right side
		If $keep = "" Then
			GUICtrlCreateLabel($sign, $x_temp, $y)
		Else
			Assign($keep & "right" & $loop, GUICtrlCreateLabel($sign, $x_temp, $y), 2)
			Assign($varname, Eval($varname) & $keep & "right" & $loop & "|", 2)
		EndIf
		GUICtrlSetColor(-1, $color1)
		$y += $jumps
	Next
	If $keep <> "" Then $all_bars &= "|" & $keep
EndFunc   ;==>v_bar

Func hide_bar($varname)
	$vararray = StringSplit(Eval($varname), "|")
	For $loop = 1 To $vararray[0]
		If $vararray[$loop] <> "" Then ControlHide($gui, "", Eval($vararray[$loop]))
		;if $vararray[$loop] <> "" Then ConsoleWrite(eval($vararray[$loop]) & "-" & $vararray[$loop] & @CR)
	Next
EndFunc   ;==>hide_bar

Func show_bar($varname)
	$vararray = StringSplit(Eval($varname), "|")
	For $loop = 1 To $vararray[0]
		If $vararray[$loop] <> "" Then ControlShow($gui, "", Eval($vararray[$loop]))
	Next
EndFunc   ;==>show_bar

Func show_hide($action, $globalvarname, $varpart)
	If $action = "hide" Then
		For $loop = 1 To $varpart
			hide_bar($globalvarname & "_" & $loop)
		Next
	Else
		For $loop = 1 To $varpart
			show_bar($globalvarname & "_" & $loop)
		Next
	EndIf
EndFunc   ;==>show_hide

;cache tous les liens facultatifs
;~ $all_bars_ar = stringsplit($all_bars, "|")
;~ For $loop = 1 To Ubound($all_bars_ar)-1
;~ 	hide_bar($all_bars_ar[$loop])
;~ Next
;ConsoleWrite($all_bars)


; GUI MESSAGE LOOP
GUISetState()


Global $change_mode, $change_tab, $old_tab
; here the endless loop to check if something checked, or a button clicked.
Do
	If $change_tab <> False Then $change_tab = False
	$msg = GUIGetMsg()
	$which_tab = ControlCommand($gui, "", $tab, "CurrentTab", "")
	If $old_tab <> $which_tab Then
		ConsoleWrite($old_tab & " " & $which_tab & @CR)
		$old_tab = $which_tab
		$change_tab = True
	EndIf


	If $mode = "easy" Then
		If $which_tab = 1 Then
			If $change_mode = True Or $change_tab = True Or $msg = $use_dns Or $msg = $use_dyndns Or $msg = $cb_local Then
				$change_mode = False
				If GUICtrlRead($use_dns) <> 1 Then
					show_hide("hide", "dnsreq", 3)
					ControlHide($gui, "", $legend_dns)
					ControlHide($gui, "", $dn_label)
					ControlHide($gui, "", $dns_icon)
					ControlHide($gui, "", $cert_CN)
					GUICtrlSetState($use_dyndns, $GUI_UNCHECKED)
					ControlHide($gui, "", $use_dyndns)
				ElseIf GUICtrlRead($use_dns) = 1 Then
					show_hide("show", "dnsreq", 3)
					ControlShow($gui, "", $legend_dns)
					ControlShow($gui, "", $dn_label)
					ControlShow($gui, "", $dns_icon)
					ControlShow($gui, "", $use_dyndns)
					ControlShow($gui, "", $cert_CN)
				EndIf

				If GUICtrlRead($use_dyndns) <> 1 Then
					show_hide("hide", "dnsfeed", 6)
					ControlHide($gui, "", $legend_dyndns)
				ElseIf GUICtrlRead($use_dyndns) = 1 Then
					show_hide("show", "dnsfeed", 6)
					ControlShow($gui, "", $legend_dyndns)
				EndIf

				If GUICtrlRead($cb_local) <> 1 Then
					show_hide("hide", "localhttp", 3)
				ElseIf GUICtrlRead($cb_local) = 1 Then
					show_hide("show", "localhttp", 3)
				EndIf
			EndIf

			If GUICtrlRead($stunout_port) <> GUICtrlRead($easy_stunport) Then GUICtrlSetData($easy_stunport, GUICtrlRead($stunout_port))
		EndIf

		Switch $msg
			Case $btn_advanced
				$msg = ""
				advanced_mode()
		EndSwitch
	EndIf


	If $msg <> "" And $mode = "advanced" Then

		If $which_tab = 2 Then
			;active or not Stunnel log file
			If GUICtrlRead($cb_no_stunlog) <> 1 Then
				GUICtrlSetState($cb_hfs_stunlog, $GUI_ENABLE)
			Else
				GUICtrlSetState($cb_hfs_stunlog, $GUI_UNCHECKED)
				GUICtrlSetState($cb_hfs_stunlog, $GUI_DISABLE)
			EndIf
			;affiche/masque le niveau de log d'Stunnel
			If GUICtrlRead($cb_hfs_stunlog) = 1 Then
				ControlShow($gui, "", $hfs_stunlog_level)
			Else
				ControlHide($gui, "", $hfs_stunlog_level)
			EndIf
			;Affiche/masque Adress2Name
			If GUICtrlRead($cb_hfs_a2n) = 1 Then
				ControlShow($gui, "", $hfs_a2n_1_ip)
				ControlShow($gui, "", $hfs_a2n_1_name)
				ControlShow($gui, "", $hfs_a2n_2_ip)
				ControlShow($gui, "", $hfs_a2n_2_name)
			Else
				ControlHide($gui, "", $hfs_a2n_1_ip)
				ControlHide($gui, "", $hfs_a2n_1_name)
				ControlHide($gui, "", $hfs_a2n_2_ip)
				ControlHide($gui, "", $hfs_a2n_2_name)
			EndIf
			; check local http state, and show/hide the IPs fields and enable/disable listening on one IP
			If GUICtrlRead($cb_local) = 1 Then
				ControlShow($gui, "", $local_network)
				GUICtrlSetState($cb_hfs_listenon, $GUI_UNCHECKED)
				GUICtrlSetState($cb_hfs_listenon, $GUI_DISABLE)
			Else
				ControlHide($gui, "", $local_network)
				GUICtrlSetState($cb_hfs_listenon, $GUI_ENABLE)
				GUICtrlSetState($cb_hfs_listenon, 1)
			EndIf
			; Show/Hide Local IP input
			If GUICtrlRead($cb_stun_local_opt) = 1 Then
				ControlShow($gui, "", $local_ip)
			Else
				ControlHide($gui, "", $local_ip)
			EndIf
		EndIf

		Switch $msg
			;		Case $msg = $btn_winxp_fw
			;			ShellExecute("set allowedprogram " & @ScriptDir & "stunnel\stunnel.exe allow_stunnel ENABLE")

			Case $btn_advanced
				$msg = ""
				easy_mode()
		EndSwitch
	EndIf


	If $msg <> "" Then

		If $which_tab = 1 Then
			; red fields if both external IP and Domain name are empty
			; also disable the makefile button as it's an absolutely necessary option.
			$extip = GUICtrlRead($ext_ip)
			$certCN = GUICtrlRead($cert_CN)
			If $extip = "" And $certCN = "" And $color <> "rouge" Then
				ControlDisable($gui, "", $btn_makeall)
				GUICtrlSetBkColor($ext_ip, 0xFF0000)
				GUICtrlSetBkColor($cert_CN, 0xFF0000)
				$color = "rouge"
			ElseIf $extip <> "" Or $certCN <> "" And $color = "rouge" Then
				ControlEnable($gui, "", $btn_makeall)
				GUICtrlSetBkColor($ext_ip, 0xFFFFFF)
				GUICtrlSetBkColor($cert_CN, 0xFFFFFF)
				$color = "blanc"
			EndIf
		EndIf

		Switch $msg
			Case $btn_read_hfsevents
				open_txt($hfseventsfile)
			Case $btn_read_hfsini
				open_txt($hfsinifile)
			Case $btn_read_pemconf
				open_txt($pemconffile)
			Case $btn_read_stunnelconf
				open_txt($stunnelconffile)
			Case $btn_read_stunnelpem
				open_pem($stunnelpemfile)
			Case $btn_read_all
				open_txt($hfseventsfile)
				open_txt($hfsinifile)
				open_txt($pemconffile)
				open_txt($stunnelconffile)
				open_pem($stunnelpemfile)

			Case $btn_erase_checked
				GUICtrlSetData($erased, erase_files())


			Case $GUI_EVENT_CLOSE
				ExitLoop

			Case $btn_quit
				ExitLoop

			Case $btn_launchquit
				If GUICtrlRead($cb_hfs_run_stunnel) <> 1 And $mode <> "easy" Then Run(@ScriptDir & "\sHFS\stunnel\stunnel.exe")
				Run(@ScriptDir & "\sHFS\hfs.exe")
				ExitLoop


			Case $btn_link_sHFS
				ShellExecute("http://www.rejetto.com/forum/index.php?topic=7080.0")

			Case $btn_link_hfs
				ShellExecute("http://www.rejetto.com/hfs/")

			Case $btn_link_openssl
				ShellExecute("http://www.openssl.org/")

			Case $btn_link_stunnel
				ShellExecute("http://www.stunnel.org/")

			Case $btn_tuto_principal
				ShellExecute("http://www.rejetto.com/wiki/index.php/HFS:_Secure_your_server")

			Case $btn_tuto_stunlog
				ShellExecute("http://www.rejetto.com/forum/index.php?topic=6651.msg1043256#msg1043256")

			Case $btn_hfs_beta
				ShellExecute("http://www.rejetto.com/forum/index.php?board=33.0")

			Case $btn_tuto_filezilla
				ShellExecute("http://www.rejetto.com/forum/index.php?topic=6651.msg1040766#msg1040766")

			Case $btn_shortcut
				FileCreateShortcut(@ScriptDir & "\sHFS\hfs.exe", @DesktopDir & "\SHFS.lnk", @ScriptDir & "\sHFS\", "", "", @ScriptDir & "\confiles\icons\shortcut.ico")


			Case $btn_cert_info
				MsgBox(8192 + 64, _GetText("group_cert_title"), _GetText("cert_info"))

			Case $get_ext_ip
				$oHTTP = ObjCreate("winhttp.winhttprequest.5.1")
				$oHTTP.Open("GET", "http://freedom.rulerz.online.fr/sHFS/whatismyip.php")
				$oHTTP.Send()
				$HTMLtext = $oHTTP.Responsetext
				GUICtrlSetData($ext_ip, $HTMLtext)
				$oHTTP = 0

			Case $get_ip_alt
				ShellExecute("http://www.showmyip.com/simple/")

			Case $btn_fillurl
				$extip = GUICtrlRead($ext_ip)
				$extport = ":" & GUICtrlRead($stunout_port)
				If (GUICtrlRead($cb_hfs_https) = 1 And $extport = ":443") Then $extport = ""
				$certCN = $extip & $extport
				GUICtrlSetData($cert_CN, $certCN)

			Case $btn_probe_port
				test_port()

			Case $btn_makeall
				If $mode = "easy" Then
					advanced_mode()
					$start_mode = "easy"
				Else
					$start_mode = "not"
				EndIf

				If GUICtrlRead($progression) <> "" Then GUICtrlSetData($progression, "")
				$splash_message = _GetText("progress") & @LF
				GUICtrlSetState($tab_files, $GUI_SHOW)
				ControlSetText("", "", $progression, $splash_message)

				$conf_key_prog = conf_key()
				If $conf_key_prog = "ok_blank" Then
					$splash_message &= _GetText("prog_key_ok") & @LF & _GetText("prog_key_blank_ins") & @LF
				ElseIf $conf_key_prog = "ok_noblank" Then
					$splash_message &= _GetText("prog_key_ok") & @LF & _GetText("prog_key_no_blank_ins") & @LF
				ElseIf $conf_key_prog = "nopemconf" Then
					$splash_message &= _GetText("prog_key_keep") & @LF
				ElseIf $conf_key_prog = "stunnelpemfilerror" Then
					$splash_message &= _GetText("prog_key_openssl_error") & @LF
				Else
					$splash_message &= _GetText("prog_key_error") & @LF
				EndIf
				ControlSetText("", "", $progression, $splash_message)

				If $cb_do_only_key <> 1 Then
					$conf_HFSevents_prog = conf_HFS_events()
					If $conf_HFSevents_prog = "ok" Then
						$splash_message &= _GetText("prog_hfsevents_ok")
					ElseIf $conf_HFSevents_prog = "nohfsevents" Then
						$splash_message &= _GetText("prog_hfsevents_keep")
					ElseIf $conf_HFSevents_prog = "hfseventsmod" Then
						$splash_message &= _GetText("prog_hfsevents_mod")
					ElseIf $conf_HFSevents_prog = "hfseventsmoderror" Then
						$splash_message &= _GetText("prog_hfsevents_moderror")
					ElseIf $conf_HFSevents_prog = "hfseventscreaterror" Then
						$splash_message &= _GetText("prog_hfsevents_createrror")
					Else
						$splash_message &= ""
					EndIf
					ControlSetText("", "", $progression, $splash_message)


					$conf_HFS_prog = conf_HFS()
					If $conf_HFS_prog = "ok" Then
						$splash_message &= _GetText("prog_hfsini_ok") & @LF
					ElseIf $conf_HFS_prog = "nohfsini" Then
						$splash_message &= _GetText("prog_hfsini_keep") & @LF
					Else
						$splash_message &= _GetText("prog_hfsini_error") & @LF
					EndIf
					ControlSetText("", "", $progression, $splash_message)

					$conf_stunnel_prog = conf_stunnel()
					If $conf_stunnel_prog = "ok" Then
						$splash_message &= _GetText("prog_stunnel_ok")
					ElseIf $conf_stunnel_prog = "nostunnelconf" Then
						$splash_message &= _GetText("prog_stunnel_keep")
					Else
						$splash_message &= _GetText("prog_stunnel_error")
					EndIf
					ControlSetText("", "", $progression, $splash_message)

					hfsexe_renamer()
				EndIf

				If $start_mode = "easy" Then
					easy_mode(False, True)
				Else
					GUICtrlDelete($tab_files)
					GUICtrlDelete($tab_about)
					tab_files()
					tab_about()
					check_files()
					ControlSetText("", "", $progression, $splash_message)
				EndIf

;~ 			Case $msg = $btn_readhfsini
;~ 				make_hfsini_section()

;~ 				read_hfsini("save-options-on-exit", $cb_hfs_saveopt_onexit)
;~ 				read_hfsini("dont-include-port-in-url", $cb_hfs_dont_incl_port)
;~ 				read_hfsini("no-reply-ban", $cb_hfs_ban_noreply)
;~ 				read_hfsini("https-url", $cb_hfs_https)
;~ 				read_hfsini("find-external-on-startup", $cb_hfs_dont_find_extip, "no")
;~ 				read_hfsini("search-better-ip", $cb_hfs_dont_search_betterip, "no")
;~ 				read_hfsini("browse-localhost", $cb_hfs_browse_localhost, "no")

;~ 				remove_hfsini_section()

		EndSwitch
	EndIf
Until $msg == $GUI_EVENT_CLOSE